#include "cv.h"
#include "highgui.h"


char wndname[] = "Gauss";
char tbarname[] = "Kernel size";
int kernel_size = 0;

IplImage *image = 0, *simage = 0 ;

// define a trackbar callback
void on_trackbar(int h)
{
    cvSmooth( image, simage, CV_GAUSSIAN, 2 * kernel_size + 1, 2 * kernel_size + 1);
    cvShowImage(wndname, simage);
}

int main( int argc, char** argv )
{
    char* filename = argc == 2 ? argv[1] : (char*)"fruits.jpg";
    
    if( (image = cvLoadImage( filename, 1)) == 0 )
        return -1;

    // Create the output image
    simage = cvCreateImage(cvSize(image->width,image->height), IPL_DEPTH_8U, 3);
    
    // Create a window
    cvNamedWindow(wndname, 1);

    // create a toolbar 
    cvCreateTrackbar(tbarname, wndname, &kernel_size, 10, on_trackbar);

    // Show the image
    on_trackbar(0);

    // Wait for a key stroke; the same function arranges events processing
    cvWaitKey(0);
    cvReleaseImage(&image);
    cvReleaseImage(&simage);
    
    cvDestroyWindow(wndname);

    return 0;
}
